## libquazip1-qt5 1.4

=== debian/changelog ===
libquazip1-qt5 (1.4-1.1build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:38:23 +0000

libquazip1-qt5 (1.4-1.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:12:31 +0000

libquazip1-qt5 (1.4-1.1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:41:43 +0000

libquazip1-qt5 (1.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063132

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:24:19 +0000

libquazip1-qt5 (1.4-1) unstable; urgency=high

  * New upstream version
  * Add dependencies on Qt5 and zlib1g (Closes: #1028641)

 -- Ben Westover <me@benthetechguy.net>  Sun, 05 Feb 2023 15:48:12 -0500

libquazip1-qt5 (1.3-1) unstable; urgency=medium

  * Initial Package (Closes: #1023083)

 -- Ben Westover <me@benthetechguy.net>  Sun, 30 Oct 2022 00:46:32 -0400
