=== debian/control ===
Source: libquazip1-qt5
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ben Westover <me@benthetechguy.net>
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 cmake,
 doxygen,
 graphviz,
 qtbase5-dev,
 libbz2-dev,
 zlib1g-dev
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/BenTheTechGuy/libquazip1-qt5.git
Vcs-Browser: https://salsa.debian.org/BenTheTechGuy/libquazip1-qt5
Homepage: https://github.com/stachenov/quazip
Rules-Requires-Root: no

Package: libquazip1-qt5-1t64
Provides: ${t64:Provides}
Replaces: libquazip1-qt5-1
Breaks: libquazip1-qt5-1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt/C++ wrapper over minizip - Version 1 (Qt5)
 QuaZip is the C++ wrapper for Gilles Vollant's ZIP/UNZIP package (AKA
 Minizip) using Trolltech's Qt library.
 This package contains version 1 of the library, compiled for use with
 Qt version 5.

Package: libquazip1-qt5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 qtbase5-dev,
 libbz2-dev,
 zlib1g-dev,
 libquazip1-qt5-1t64 (= ${binary:Version})
Description: Qt/C++ wrapper over minizip - Version 1 (Qt5) - development files
 QuaZip is the C++ wrapper for Gilles Vollant's ZIP/UNZIP package (AKA
 Minizip) using Trolltech's Qt library.
 This package contains development files for version 1 of the library,
 compiled for use with Qt version 5.

Package: libquazip1-qt5-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Qt/C++ wrapper over minizip - Version 1 (Qt5) - documentation
 QuaZip is the C++ wrapper for Gilles Vollant's ZIP/UNZIP package (AKA
 Minizip) using Trolltech's Qt library.
 This package contains documentation for version 1 of the library,
 compiled for use with Qt version 5.
