=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/quazip-$1\.tar\.gz/ \
  https://github.com/stachenov/quazip/tags .*/v?(\d\S+)\.tar\.gz
