## libquazip1-qt5 1.5

=== debian/changelog ===
libquazip1-qt5 (1.5-1) unstable; urgency=medium

  * New upstream version

 -- Ben Westover <me@benthetechguy.net>  Fri, 13 Jun 2025 16:20:26 -0400

libquazip1-qt5 (1.4-1) unstable; urgency=medium

  * New upstream version
  * Add dependencies on Qt5 and zlib1g (Closes: #1028641)

 -- Ben Westover <me@benthetechguy.net>  Sun, 05 Feb 2023 15:48:12 -0500
