=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libquazip1-qt5
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ben Westover <me@benthetechguy.net>
+Maintainer: Ben Westover <me@benthetechguy.net>
 Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
@@ -11,16 +10,16 @@
  qtbase5-dev,
  libbz2-dev,
  zlib1g-dev
-Standards-Version: 4.6.1
-Vcs-Git: https://salsa.debian.org/BenTheTechGuy/libquazip1-qt5.git
-Vcs-Browser: https://salsa.debian.org/BenTheTechGuy/libquazip1-qt5
+Standards-Version: 4.7.2
+Vcs-Git: https://salsa.debian.org/debian/libquazip1-qt5.git
+Vcs-Browser: https://salsa.debian.org/debian/libquazip1-qt5
 Homepage: https://github.com/stachenov/quazip
 Rules-Requires-Root: no
 
 Package: libquazip1-qt5-1t64
 Provides: ${t64:Provides}
 Replaces: libquazip1-qt5-1
-Breaks: libquazip1-qt5-1 (<< ${source:Version})
+Breaks: libquazip1-qt5-1 (<< 1.4-1.1)
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -48,6 +47,7 @@
 
 Package: libquazip1-qt5-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Description: Qt/C++ wrapper over minizip - Version 1 (Qt5) - documentation
